<template>
  <div class="relative w-full max-w-full py-0 mx-auto my-0">
    <div
      class="overflow-hidden py-8 px-0 min-h-[calc(50vh-72px)] register-form-bg"
    >
      <div>
        <div class="w-full max-w-full py-0 mx-auto my-0">
          <div
            class="p-0 w-[540px] max-w-full my-0 mx-auto rounded-[40px] relative register-form-wrapper"
          >
            <div
              class="flex justify-center mb-[40px] relative items-center flex-wrap"
            >
              <h2
                class="text-[40px] w-auto m-0 font-bold text-[var(--title-font-color)] leading-[52px]"
              >
                {{ $t("joinnow") }}
              </h2>
            </div>
            <div>
              <el-form
                ref="formRef"
                label-width="200px"
                label-position="left"
                :rules="formRules"
                :model="formModel"
              >
                <el-form-item
                  :class="{ required: rules.Username.required }"
                  :label="$t('username')"
                  prop="Username"
                >
                  <el-input
                    v-model="formModel.Username"
                    :placeholder="$t('username')"
                  />
                </el-form-item>
                <el-form-item
                  :class="{ required: rules.Password.required }"
                  :label="$t('password')"
                  prop="Password"
                >
                  <el-input
                    v-model="formModel.Password"
                    :type="inputTypePw"
                    :placeholder="$t('password')"
                  >
                    <template #suffix>
                      <div @click.prevent="showPassword('password')"></div>
                    </template>
                  </el-input>
                </el-form-item>
                <el-form-item
                  :class="{ required: rules.ConfirmPassword.required }"
                  :label="$t('confirm_password')"
                  prop="ConfirmPassword"
                  show-password
                >
                  <el-input
                    v-model="formModel.ConfirmPassword"
                    :type="inputTypecfPw"
                    :placeholder="$t('confirm_password')"
                  >
                    <template #suffix>
                      <div @click.prevent="showPassword('cfpassword')"></div>
                    </template>
                  </el-input>
                </el-form-item>
                <el-form-item
                  :class="{ required: rules.Currency.required }"
                  :label="$t('currency')"
                  prop="Currency"
                >
                  <el-select
                    v-model="formModel.Currency"
                    style="width: 100%"
                    :placeholder="$t('select_currency')"
                    :disabled="currencies.length <= 0"
                  >
                    <el-option
                      v-for="currency in currencies"
                      :key="currency"
                      :value="String(currency.Currency)"
                    >
                      <div class="flex justify-between w-full">
                        <div class="flex items-center">
                          <div>
                            {{ currency.Currency }}
                          </div>
                          <div class="w-[16px] ml-[11px] currency-check-icon">
                            <font-awesome-icon icon="circle-check" />
                          </div>
                        </div>
                      </div>
                    </el-option>
                  </el-select>
                </el-form-item>
                <template v-for="property in availableProperties" :key="property.PropertyName">
                <theme-common-otp-field
                  v-if="property.PropertyName === 'Phone'"
                  v-model="formModel"
                  :label="property.PropertyNameForDisplay"
                  :phone-property="property.PropertyName"
                  :is-required="rules[property.PropertyName].required"
                  :loading="isGettingOtpCode"
                  :next-request-in-seconds="nextRequestOtpInSeconds"
                  @get-code="onGetVerificationCode"
                >
                  <template #phone>
                    <el-form-item
                      :label="property.PropertyNameForDisplay"
                      :prop="property.PropertyName"
                      :class="[
                        `register-${property.PropertyName.toLowerCase()}`,
                        rules[property.PropertyName].required ? 'required' : '',
                      ]"
                    >
                      <div class="flex flex-1 gap-2">
                          <el-input
                            v-model="formModel[property.PropertyName]"
                            :placeholder="property.PropertyName"
                          >
                            <template #suffix>
                              <el-tooltip
                                class="box-item"
                                effect="dark"
                                :content="
                                  $t(
                                    'valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes'
                                  )
                                "
                                placement="bottom"
                              >
                                <el-icon
                                  class="el-input__icon"
                                  color="var(--primary)"
                                >
                                  <info-filled />
                                </el-icon>
                              </el-tooltip>
                            </template>
                          </el-input>
                        </div>
                    </el-form-item>
                  </template>
                </theme-common-otp-field>
                <el-form-item
                  v-else
                  :label="property.PropertyNameForDisplay"
                  :prop="property.PropertyName"
                  :class="[
                    `register-${property.PropertyName.toLowerCase()}`,
                    rules[property.PropertyName].required ? 'required' : '',
                  ]"
                >
                  <el-select
                    v-if="property.PropertyName === 'Bank'"
                    v-model="formModel.Bank"
                    style="width: 100%"
                    :placeholder="$t('select_bank')"
                    :disabled="bankOptions.length <= 0"
                  >
                    <el-option
                      v-if="bankOptions.length <= 0"
                      label="--"
                      value="0"
                    />
                    <el-option
                      v-else
                      v-for="bank in bankOptions"
                      :key="bank.Id"
                      :label="bank.BankName"
                      :value="String(bank.Id)"
                    >
                      <div class="flex justify-between w-full">
                        <div class="flex items-center">
                          <div>
                            {{ bank.BankName }}
                          </div>
                          <div class="w-[16px] ml-[11px] bank-check-icon">
                            <font-awesome-icon icon="circle-check" />
                          </div>
                        </div>
                      </div>
                    </el-option>
                  </el-select>
                  <div v-else-if="property.PropertyName === 'Gender'">
                    <el-radio v-model="formModel.Gender" label="male">{{
                      $t("male")
                    }}</el-radio>
                    <el-radio v-model="formModel.Gender" label="female">{{
                      $t("female")
                    }}</el-radio>
                  </div>
                  <el-date-picker
                    v-else-if="property.PropertyName === 'DateOfBirth'"
                    v-model="formModel.DateOfBirth"
                    type="date"
                    value-format="YYYY-MM-DD"
                  />
                  <el-input
                    v-else-if="property.PropertyName === 'Referral'"
                    v-model="formModel[property.PropertyName]"
                    :disabled="referralQuery.length"
                    :placeholder="$t('referral')"
                  >
                  </el-input>
                  <el-input
                    v-else-if="property.PropertyName === 'BankAccountName'"
                    v-model="formModel[property.PropertyName]"
                    :placeholder="property.PropertyNameForDisplay"
                    :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                  ></el-input>
                  <el-input
                    v-else-if="property.PropertyName === 'BankAccountNumber'"
                    v-model="formModel[property.PropertyName]"
                    :placeholder="property.PropertyNameForDisplay"
                    :disabled="formModel.Bank === '0' || formModel.Bank === ''"
                    :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')"
                  ></el-input>
                  <el-input
                    v-else
                    v-model="formModel[property.PropertyName]"
                    :placeholder="property.PropertyNameForDisplay"
                  ></el-input>
                </el-form-item>
                </template>
                <el-form-item
                  v-if="cashAgentQuery.length"
                  :label="$t('agent_name')"
                  prop="AgentName"
                >
                  <el-input
                    v-model="formModel.AgentName"
                    :class="{
                      'pointer-events-none opacity-80': cashAgentQuery.length,
                    }"
                  />
                </el-form-item>
                <div
                  v-if="!clientCaptcha.IsHidden"
                  class="btn-click-captcha-to-verify"
                >
                  <el-form-item
                    :class="{ required: rules.Captcha.required }"
                    prop="Captcha"
                    :show-message="true"
                    label=""
                  >
                    <div id="captcha-button">
                      <div id="captcha-pop-up-verify" class="w-full">
                        <template
                          v-if="
                            !captchaErrorMsg.length &&
                            formModel.Captcha.length == 5 &&
                            !isDialogVisible
                          "
                        >
                          <div class="relative w-[18px] h-[18px]">
                            <img
                              :src="
                                getAssetImage(
                                  'assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png'
                                )
                              "
                              alt="verify icon success"
                              loading="lazy"
                            />
                          </div>
                          <span class="whitespace-nowrap">{{
                            $t("successful_verification")
                          }}</span>
                        </template>
                        <template v-else>
                          <div
                            class="flex items-center justify-center w-full gap-1"
                            @click="isDialogVisible = true"
                          >
                            <div class="relative w-[18px] h-[18px]">
                              <img
                                :src="
                                  getAssetImage(
                                    'assets/theme/light_flexible_1/desktop/images/menu/capcha.png'
                                  )
                                "
                                alt="verify icon"
                                loading="lazy"
                              />
                            </div>
                            <span>{{ $t("click_to_verify") }}</span>
                          </div>
                        </template>
                      </div>
                    </div>
                  </el-form-item>
                </div>
                <template class="flex justify-center">
                  <div class="mt-5">
                    <el-button
                      type="primary"
                      round
                      @click="onRegister(formRef)"
                      >{{ $t("joinnow") }}</el-button
                    >
                  </div>
                </template>
                <p class="w-full mt-6 text-base text-[#707585] text-center">
                  {{ $t("already_have_an_account") }}?
                  <nuxt-link
                    class="text-[var(--accent-color)] relative ml-[10px] hover:text-[var(--accent-color-light)] focus:text-[var(--accent-color-light)]"
                    to="/login"
                    >{{ $t("capital_login") }}</nuxt-link
                  >
                </p>
              </el-form>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

  <div class="captcha-dialog-container">
    <el-dialog
      v-model="isDialogVisible"
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      width="320px"
      @open="formModel.Captcha = ''"
      @close="formRef?.validateField('Captcha')"
    >
      <utils-client-captcha
        v-if="!clientCaptcha.IsHidden"
        v-model:captcha="formModel.Captcha"
        v-model:dialogVisible="isDialogVisible"
        :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0"
      />
    </el-dialog>
  </div>
</template>

<script lang="ts">
import { defineComponent, PropType, ref, watch } from "vue";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import useRegister from "@/composables/useRegister";
import commonHelper from "@/utils/commonHelper";

export default defineComponent({
  name: "Login",
  props: {
    themeProperties: {
      type: Array as PropType<Array<IThemePropertiesFromApi>>,
      required: true,
    },
  },
  setup() {
    const {
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      clientCaptcha,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const { getAssetImage } = commonHelper;
    const darkBackground = `url(${getAssetImage(
      "assets/theme/black_modern_1/fonts/bg_page-user-form.svg"
    )}`;
    const lightBackground = `url(${getAssetImage(
      "assets/theme/black_modern_1/fonts/bg_page-user-form_1.svg"
    )}`;
    const isDialogVisible = ref(false);
    watch(
      () => isDialogVisible.value,
      () => {
        const sidebar: HTMLElement | null = document.querySelector(
          'div[layout="black_modern_desktop_1"] aside.el-aside'
        );
        if (!sidebar) return;
        if (isDialogVisible.value) {
          sidebar.style.opacity = "0";
          sidebar.style.pointerEvents = "none";
          return;
        }
        sidebar.style.opacity = "1";
        sidebar.style.pointerEvents = "all";
      }
    );
    return {
      formModel,
      formRef,
      formRules,
      onRegister,
      currencies,
      isLoading,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      availableProperties,
      referralQuery,
      bankOptions,
      cashAgentQuery,
      darkBackground,
      lightBackground,
      getAssetImage,
      clientCaptcha,
      isDialogVisible,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    };
  },
});
</script>

<style scoped>
:deep(.el-input.is-disabled .el-input__inner) {
  -webkit-text-fill-color: var(--title-font-color) !important;
}
.register-form-bg {
  background: v-bind("lightBackground") no-repeat;
  background-size: 620px;
}
html.dark .register-form-bg {
  background: v-bind("darkBackground") no-repeat;
  background-size: 620px;
}
.register-form-wrapper {
  background: var(--background2);
  box-shadow: var(--box-shadow);
  padding: 40px 30px;
  position: relative;
}
.register-form-wrapper h2 {
  color: var(--text);
}
:deep(.el-select .el-input.is-focus .el-input__inner) {
  box-shadow: var(--box-shadow-inset) !important;
}
:deep(.el-input.is-disabled .el-input__inner) {
  --el-disabled-bg-color: var(--background2);
  --el-disabled-text-color: var(--title-font-color);
  -webkit-text-fill-color: var(--background2);
  box-shadow: var(--box-shadow-inset) !important;
  opacity: 1;
}
:deep(.el-form-item) {
  display: flex;
  justify-content: space-between;
  align-items: center;
}
:deep(.el-input) {
  display: flex;
  justify-content: flex-end;
}
:deep(.el-input__inner) {
  height: 40px;
  width: 300px;
  padding: 8px 16px;
  font-family: Roboto, sans-serif;
  font-size: 14px;
  font-weight: 400;
  line-height: 20px;
  color: var(--title-font-color);
  background: var(--background2);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset);
  border-radius: 8px;
  box-sizing: border-box;
}
:deep(.el-form-item__content .el-input__inner) {
  width: 300px !important;
}
:deep(button.el-button) {
  background-color: var(--button-bg) !important;
  opacity: unset !important;
  box-shadow: var(--box-shadow);
  display: inline-flex;
  align-items: center;
  justify-content: center;
  height: 40px;
  font-size: 14px;
  box-sizing: border-box;
  text-align: center;
  user-select: none;
  padding: 0 20px;
  white-space: nowrap;
  overflow: hidden;
  font-weight: 600;
  text-decoration: none;
  transition: all 0.5s;
  border-radius: 6px;
  border: none;
}
:deep(.el-button span) {
  @apply text-sm font-bold leading-4 uppercase;
}
:deep(.el-select:hover .el-input__inner) {
  background: var(--background2);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset);
}
:deep(.el-input__inner:focus) {
  background: var(--background2);
  border: 1px solid transparent;
  box-shadow: var(--box-shadow-inset) !important;
}
:deep(.register-phone .el-form-item__content) {
  display: block;
}
:deep(.register-phone .el-form-item__content .el-form-item__error) {
  width: max-content;
}
</style>
